package com.bzd.web.controller.kc.bb;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.kc.bb.SKcBbSalesanddispensingService;

import java.util.List;

/**
*
* 拆零报表 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-14
*/
@Controller
@RequestMapping(value = "kc/skcbbsalesanddispensing")
public class SKcBbSalesanddispensingController extends BaseController {

    // 页面跳转前缀
    private String prefix = "kc/bb";

    @Autowired
    private SKcBbSalesanddispensingService sKcBbSalesanddispensingService;

    /**
    * 拆零报表 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("kc:bb:view")
    @GetMapping("/sKcBbSalesanddispensingAdd")
    public String add() {
        return prefix + "/SKcBbSalesanddispensingAdd";
    }

    /**
    * 拆零报表 新增
    *
    * @return
    */
    @Log(title = "拆零报表新增", businessType = BusinessType.INSERT)
    @PostMapping("/sKcBbSalesanddispensingAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sKcBbSalesanddispensingService.addSKcBbSalesanddispensing(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 拆零报表 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("kc:bb:view")
    @GetMapping("/sKcBbSalesanddispensingView")
    public String skcbbsalesanddispensingListView() {
        return prefix + "/SKcBbSalesanddispensingList";
    }

    /**
    * 拆零报表 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("kc:bb:sKcBbSalesanddispensingList")
    @PostMapping("/sKcBbSalesanddispensingList")
    @ResponseBody
    public TableDataInfo skcbbsalesanddispensingList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sKcBbSalesanddispensingService.findSKcBbSalesanddispensingList(pd);
        return getDataTable(pageData);
    }

    /**
    * 拆零报表 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("kc:bb:remove")
    @Log(title = "拆零报表删除", businessType = BusinessType.DELETE)
    @PostMapping("/sKcBbSalesanddispensingRemove")
    @ResponseBody
    public AjaxResult skcbbsalesanddispensingRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sKcBbSalesanddispensingService.SKcBbSalesanddispensingRemove(pd);
        return toAjax(integer);
    }

    /**
    * 拆零报表 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("kc:bb:edit")
    @GetMapping("/sKcBbSalesanddispensingEdit/{id}")
    public String skcbbsalesanddispensingView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sKcBbSalesanddispensingService.findSKcBbSalesanddispensingList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/skcbbsalesanddispensingPageEdit";
        }
        return prefix+ "/skcbbsalesanddispensingEdit";
    }

    /**
    * 拆零报表保存修改的数据
    */
    @RequiresPermissions("kc:bb:edit")
    @Log(title = "拆零报表修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sKcBbSalesanddispensingEdit")
    @ResponseBody
    public AjaxResult skcbbsalesanddispensingEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sKcBbSalesanddispensingService.updateSKcBbSalesanddispensing(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表skcbbsalesanddispensing with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表skcbbsalesanddispensing with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
